#include <LiquidCrystal.h>
LiquidCrystal lcd(8, 9, 4, 5, 6, 7); //Angabe der erforderlichen Pins
 
// erstellen einiger Variablen
int Taster = 0;
int Status = 0; 
int Timer100ms = 0;
//0: Standby
//1: Preheat 1-3°C /per Sek
//2: Soak: 150°C, 60sek
//3: Soak to Reflow Rise
//4: Reflow: 25°C  above TAL, where solder get liquid, 40 - 80 sek 
//5: Cooling, 2-4°C per Sek down

const int RelayPin = 2;      // Ausgangspin Relay
int Analogwert = 0;
int Hysterese = 1; // Hysterese Temperatur bei der Regelung in °C
int TemperaturIst = 0;
int TemperaturSoll = 25;
int TemperaturADC = 0;
int TemperatureReflowSoll = 210;  //°C
int TemperatureSoakSoll = 150;    //°C
int ReflowMaxTime = 700;           //x100msek  , 60 sek empfohlen = 600
int SoakMaxTime = 600;           //x100msek , 60 sek empfohlen = 600
boolean Heizen = true;



#define Tasterrechts 0
#define Tasteroben 1
#define Tasterunten 2
#define Tasterlinks 3
#define Tasterselect 4
#define KeinTaster 5

// 100k ParCan thermistor (104GT-2)
// ATC Semitec 104GT-2 (Used in ParCan)
// Verified by linagee. Source: http://shop.arcol.hu/static/datasheets/thermistors.pdf
// Calculated using 4.7kohm pullup, voltage divider math, and manufacturer provided temp/resistance
const short temptable[][2] {
  {    1, 713 },
  {   17, 300 }, // top rating 300C
  {   20, 290 },
  {   23, 280 },
  {   27, 270 },
  {   31, 260 },
  {   37, 250 },
  {   43, 240 },
  {   51, 230 },
  {   61, 220 },
  {   73, 210 },
  {   87, 200 },
  {  106, 190 },
  {  128, 180 },
  {  155, 170 },
  {  189, 160 },
  {  230, 150 },
  {  278, 140 },
  {  336, 130 },
  {  402, 120 },
  {  476, 110 },
  {  554, 100 },
  {  635,  90 },
  {  713,  80 },
  {  784,  70 },
  {  846,  60 },
  {  897,  50 },
  {  937,  40 },
  {  966,  30 },
  {  986,  20 },
  { 1000,  10 },
  { 1010,   0 }
};

void LCDDisplay()
{

//16x2 LCD Keypad
lcd.setCursor(0,0); // Angabe des Cursorstartpunktes oben links.
lcd.print("T-Ist: "); // Ausgabe des Textes "Nachricht".
if (TemperaturIst < 100){
    lcd.setCursor(7,0); // Angabe des Cursorstartpunktes oben links.
    lcd.print(" ");
    lcd.setCursor(8,0); // Angabe des Cursorstartpunktes oben links. 
    }
    else{
    lcd.setCursor(7,0); // Angabe des Cursorstartpunktes oben links.  
    }
lcd.print(TemperaturIst); // Zeigt die Sekunden seit Start des Programms in Sekunden an.
lcd.setCursor(11,0); // Angabe des Cursorstartpunktes oben links.  
lcd.print(Status); // Zeigt die Sekunden seit Start des Programms in Sekunden an.
lcd.setCursor(13,0); // Angabe des Cursorstartpunktes oben links.
lcd.print("MAX"); // Zeigt die Sekunden seit Start des Programms in Sekunden an.
lcd.setCursor(0,1); // Angabe des Cursorstartpunktes oben links.
lcd.print("T-Soll: "); // Ausgabe des Textes "Nachricht".
if (Status > 0 && TemperaturSoll<100){
    lcd.print(" ");
    lcd.setCursor(8,1); // Angabe des Cursorstartpunktes oben links.
    lcd.print(TemperaturSoll); // Zeigt die Sekunden seit Start des Programms in Sekunden an.
    }
    else if (Status > 0 && TemperaturSoll>99){
    lcd.setCursor(7,1);
    lcd.print(TemperaturSoll); // Zeigt die Sekunden seit Start des Programms in Sekunden an.
    }
else{
lcd.print("--"); // Ausgabe des Textes "Nachricht".  
}
lcd.setCursor(13,1); // Angabe des Cursorstartpunktes oben links.
lcd.print(TemperatureReflowSoll); // Zeigt die Sekunden seit Start des Programms in Sekunden an.

//lcd.print(TemperaturADC); // Zeigt die Sekunden seit Start des Programms in Sekunden an.
}

void ReadTemperature()
{
TemperaturADC = analogRead(A1); // Auslesen der Temperatur am Analogen Pin A1.
int i = 0;
while (TemperaturADC>temptable[i][0])
{i++;}
TemperaturIst= map(TemperaturADC, temptable[i][0], temptable[i+1][0], temptable[i][1], temptable[i+1][1]); //Umwandeln des Sensorwertes mit Hilfe des "map" Befehls.
}

void TemperaturRegelung()
{

if (TemperaturIst <= TemperaturSoll + Hysterese && Heizen == true){
    digitalWrite(RelayPin, LOW);
    Heizen = true;
    }
if (TemperaturIst > TemperaturSoll + Hysterese && Heizen == true){
    digitalWrite(RelayPin, HIGH);
    Heizen = false;
    } 
if (TemperaturIst <= TemperaturSoll - Hysterese && Heizen == false){
    digitalWrite(RelayPin, LOW);
    Heizen = true;
    }  

}

 
// Ab hier wird ein neuer Programmblock mit dem Namen "Tasterstatus" erstellt. Hier wird ausschließlich geprüft, welcher Taster gedrückt ist.
void Tasterstatus()
{
Analogwert = analogRead(A0); // Auslesen der Taster am Analogen Pin A0.
if (Analogwert > 1000) Taster = KeinTaster;
if (Analogwert < 50) Taster = Tasterrechts;
if (Analogwert < 195 && Analogwert > 50) Taster = Tasteroben;
if (Analogwert < 380 && Analogwert > 195) Taster = Tasterunten;
if (Analogwert < 555 && Analogwert > 380) Taster = Tasterlinks;
if (Analogwert < 790 && Analogwert > 555) Taster = Tasterselect;

switch (Taster) // Abhängig von der gedrückten Taste wird in dem folgenden switch-case Befehl entschieden, was auf dem LCD angezeigt wird.
{

case Tasteroben:
{
//lcd.print("Oben        ");
TemperatureReflowSoll++;
break;
}
case Tasterunten:
{
//lcd.print("Unten       ");
TemperatureReflowSoll--;
break;
}
case Tasterselect:
{
//lcd.print("SELECT      ");
break;
}
} //switch-case Befehl beenden

}
// Hier wird der Programmblock "Tasterstatus" abeschlossen.


void setup()
{
Serial.begin(9600);
lcd.begin(16, 2); // Starten der Programmbibliothek.
pinMode(RelayPin, OUTPUT);
}
 
void loop()
{
if (Timer100ms%10 == 0 && Status >0 ){        // Jede Sekunde Soll/Ist für den Plotter übertragen
Serial.print(TemperaturIst);
Serial.print(" ");
Serial.println(TemperaturSoll);
}

LCDDisplay();
Tasterstatus(); //Hier springt der Loop in den oben angegebenen Programmabschnitt "Tasterstatus" und liest dort den gedrückten Taster aus.
ReadTemperature();
TemperaturRegelung();
switch (Status)
    {
    case 0:
          
          TemperaturSoll = 0;
          if (Taster == Tasterselect)   //START
          {
              Status = 1;  
              Timer100ms = 0;
              TemperaturSoll = TemperaturIst;
          }
          break;
          
    case 1:   //1: Preheat 1-3°C /per Sek
        if ((TemperaturSoll < TemperatureSoakSoll) && (Timer100ms%10==0)){
            TemperaturSoll ++;
        }
        if (TemperaturIst >= TemperatureSoakSoll){
            Status = 2;
            Timer100ms = 0;
        }
        break;
      
    case 2://Soak: 150°C, 60sek
      
    TemperaturSoll = TemperatureSoakSoll; 
      if (Timer100ms > SoakMaxTime)
        {
        Status = 3;
        Timer100ms = 0;
        }
        break;
        
    case 3://Soak2Reflow 1-3°C /per Sek
      if ((TemperaturSoll < TemperatureReflowSoll) && (Timer100ms%5==0)){
            TemperaturSoll ++;
          }
      if (TemperaturIst == TemperatureReflowSoll){
          Status = 4;
          Timer100ms = 0;
      }
      break;
      
    case 4: //Reflow: 25°C  above TAL, where solder get liquid, 40 - 80 sek 
      TemperaturSoll = TemperatureReflowSoll; 
      if (Timer100ms > ReflowMaxTime)
        {
        Status = 5;
        Timer100ms = 0;
        }
        break;
        
    case 5: //Cool down: ~4°C/Sek down, TODO: Servo
    if ((TemperaturSoll > 50) && (Timer100ms%3==0)){
       TemperaturSoll --;
       }
    if (TemperaturIst <= 50){
    Status = 0;
    Timer100ms = 0;
    }
    break;
}
delay(100);
if (Status > 0)
    {Timer100ms++;}

} //Loop beenden
